#include <iostream>
#include <fstream>
#include <vector>

#include "readwrite.h"

void read_data( const std::string &file_name, std::vector<double> &x, std::vector<double> &y ) throw ( TError_File_open ) {
	std::ifstream file( file_name.c_str() );
	if( file.fail() )
        throw TError_File_open( file_name );
    x.reserve(4000);
    y.reserve(4000);
/*    for(int l=0; l<19; l++)
        file.ignore(1000, '\n');
*/
    for( int j=0; file.good(); j++ ) {
        x.resize(j+1); y.resize(j+1);
        file >> x[j] >> y[j];
    }
    if( x.back() == 0 ) {
        x.pop_back();
        y.pop_back();
    }
}

void write_data( const std::string &file_name, std::vector<double> &x, std::vector<double> &y ) throw ( TError_File_open ) {
	std::ofstream file( file_name.c_str() );
	if( file.fail() )
        throw TError_File_open( file_name );
/*    for(int l=0; l<19; l++)
        file.ignore(1000, '\n');
*/
    for( int j=0, lim_j=x.size(); j<lim_j; j++ ) {
        file << x[j] << " " << y[j] << std::endl;
    }
}

void read_data_binary( const std::string &file_name, std::vector<double> &x, std::vector<double> &y ) throw ( TError_File_open ) {
	std::ifstream file( file_name.c_str(), std::ios_base::in | std::ios_base::binary );
	if( file.fail() )
        throw TError_File_open( file_name );
    int size;
    file.read( (char*)(&size), sizeof( size ) );

    x.reserve(size);
    y.reserve(size);
    for( int j=0, lim_j=x.size(); j<lim_j; j++ ) {
        file.read( (char*)(&(x[j])), sizeof( x[j] ) );
        file.read( (char*)(&(y[j])), sizeof( y[j] ) );
    }
}

void write_data_binary( const std::string &file_name, std::vector<double> &x, std::vector<double> &y ) throw ( TError_File_open ) {
	std::ofstream file( file_name.c_str(), std::ios_base::out | std::ios_base::binary );
	if( file.fail() )
        throw TError_File_open( file_name );
	int size = x.size();
    file.write( (const char*)(&size), sizeof( size ) );
    for( int j=0, lim_j=x.size(); j<lim_j; j++ ) {
        file.write( (char*)(&(x[j])), sizeof( x[j] ) );
        file.write( (char*)(&(y[j])), sizeof( y[j] ) );
    }
}

void write_data_on_screen( std::vector<double> &x, std::vector<double> &y ) {
    for( int j=0, lim_j=x.size(); j<lim_j; j++ ) {
        std::cout << x[j] << " " << y[j] << std::endl;
    }
}
